package org.osgeo.mapguide;


/**
 * {@link MgGeometricPathInstructionType} defines enumerated values used to specify
 * the instructions contained in a geometric path. See {@link MgGeometricPathIterator}
 * for a definition of a geometric path.
 *
 */
public class MgGeometricPathInstructionType
{
   
/**
 * Defines the beginning coordinate of a new segment in a geometric
 * path.
 *
 */

   public static final int MoveTo = 0 ; 
   
/**
 * Defines a straight line from the last coordinate in the geometric
 * path to the coordinate included with this instruction.
 *
 */

   public static final int LineTo = 1 ; 
   
/**
 * Defines a quadratic curve from the last coordinate in the geometric
 * path using the first coordinate of this instruction as the end point
 * and the second coordinate as the control point.
 *
 */

   public static final int QuadTo = 2 ; 
   
/**
 * Defines a line from the current coordinate in the geometric path back
 * to the last {@link MgGeometricPathInstruction}.MoveTo, which is the beginning
 * of the last segment in the path.
 *
 */

   public static final int Close = 4 ; 
   
}

